package yrpg.application.crmvisit.plugin.form;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.AfterConvertEventArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.List;

/**
 * 单据转换插件
 * 源单:专家的基础资料库
 * 目标单：专家库
 * expert_base
 */
public class BasicDataExpertsPushConvertPlugin extends AbstractConvertPlugIn implements Plugin {

    @Override
    public void afterConvert(AfterConvertEventArgs e) {
        super.afterConvert(e);
        ExtendedDataEntity[] extendedDataEntities = e.getTargetExtDataEntitySet().FindByEntityKey("yrpg_crm_expert");
        for (ExtendedDataEntity extendedDataEntity : extendedDataEntities) {
            DynamicObject dataEntity = extendedDataEntity.getDataEntity();
            //获取源单中传入要转换的对象
            List<DynamicObject> convertSource = (List<DynamicObject>) extendedDataEntity.getValue("ConvertSource");
            for (DynamicObject source : convertSource) {
                DynamicObject object = BusinessDataServiceHelper.loadSingle(source.getLong("id"), "yrpg_yzj_expert_base");
                dataEntity.set("yrpg_expert_name", object);
            }
        }
    }
}