package yrpg.application.crmvisit.plugin.form;

import kd.bos.bill.MobileBillShowParameter;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.filter.CommonFilterColumn;
import kd.bos.filter.FilterColumn;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.BeforeCreateListDataProviderArgs;
import kd.bos.form.events.MobFilterSortInitArgs;
import kd.bos.form.events.SetFilterEvent;
import kd.bos.list.BillList;
import kd.bos.list.MobileListShowParameter;
import kd.bos.list.plugin.AbstractMobListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;


/**
 * 单据列表插件(移动端) MobFilterSortInitArgs
 * 专家库：列表插件
 * 需求：新增专家，新增专家界面，点击列表中的专家跳转到市场维护人的表单界面
 */
public class ExpertAllMobListPlugin extends AbstractMobListPlugin implements Plugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("mtoolbarap");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        if ("yrpg_add_expert".equals(key)) {
            MobileBillShowParameter showParameter = new MobileBillShowParameter();
            showParameter.setFormId("yrpg_yzj_expert_base_mob");
            showParameter.setCaption("新增专家");
            showParameter.getOpenStyle().setShowType(ShowType.Floating);
            this.getView().showForm(showParameter);
        }
    }

    @Override
    public void setFilter(SetFilterEvent e) {
        super.setFilter(e);
//        List<String> ids = new ArrayList<>();
//        ids.add(String.valueOf(UserServiceHelper.getCurrentUserId()));
//        e.getQFilters().add(new QFilter("yrpg_maintainer.id", QCP.in, ids));
    }

    @Override
    public void mobFilterSortInit(MobFilterSortInitArgs args) {
        super.mobFilterSortInit(args);
//        List<FilterColumn> filterColumnList = args.getMobFilterSortInitEvent().getFilterColumns();
//        FilterColumn orgColumn = args.getMobFilterSortInitEvent().getFilterColumn("yrpg_maintainer.number");
//        if (orgColumn == null) {
//            orgColumn = new CommonFilterColumn();
//            ((FilterColumn) orgColumn).setCaption(new LocaleString("市场维护人"));
//            ((FilterColumn) orgColumn).setFieldName("yrpg_maintainer.number");
//        }
//        if (!filterColumnList.contains(orgColumn)) {
//            String userId = String.valueOf(UserServiceHelper.getCurrentUserId());
//            orgColumn.setDefaultValue(userId);
//        }
//        args.getMobFilterSortInitEvent().addFilterColumn((FilterColumn) orgColumn);
    }
}