package yrpg.application.crmvisit.plugin.form;

import kd.bos.bill.MobileBillShowParameter;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.filter.CommonFilterColumn;
import kd.bos.filter.FilterColumn;
import kd.bos.form.CloseCallBack;
import kd.bos.form.MobileFormShowParameter;
import kd.bos.form.OpenStyle;
import kd.bos.form.ShowType;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.MobFilterSortInitArgs;
import kd.bos.form.events.SetFilterEvent;
import kd.bos.list.MobileListShowParameter;
import kd.bos.list.plugin.AbstractMobListPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.user.UserServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.EventObject;
import java.util.List;


/**
 * 单据列表插件(移动端) MobFilterSortInitArgs
 * 市场维护人：列表插件
 * 需求：新增专家，先弹一个输入框，输入执业证书编号，如果和现有基础资料库重复，则弹出申请维护人界面，如果不重复，则是新增专家界面
 * 需求更新：弹出专家库界面
 */
public class ExpertUpholdMobListPlugin extends AbstractMobListPlugin implements Plugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addItemClickListeners("mtoolbarap");
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        String key = evt.getItemKey();
        if ("yrpg_expert".equals(key)) {
//            MobileFormShowParameter parameter = new MobileFormShowParameter();
//            parameter.setFormId("yrpg_expertpopup");
//            OpenStyle openStyle = parameter.getOpenStyle();
//            openStyle.setShowType(ShowType.Floating);
//            parameter.setCloseCallBack(new CloseCallBack(getPluginName(), "yrpg_expertpopup"));
//            getView().showForm(parameter);

//            MobileListShowParameter showParameter = new MobileListShowParameter();
//            showParameter.setFormId("bos_moblist");
//            showParameter.setBillFormId("yrpg_crm_expert");
////            QFilter qFilter = new QFilter("name", QCP.equals, "这是用来阻止他搜索全部");
////            showParameter.getListFilterParameter().getQFilters().add(qFilter);
//            showParameter.getOpenStyle().setShowType(ShowType.Floating);
//            this.getView().showForm(showParameter);


            MobileBillShowParameter showParameter = new MobileBillShowParameter();
            showParameter.setFormId("yrpg_relationship_bind_mob");
            showParameter.getOpenStyle().setShowType(ShowType.Floating);
            this.getView().showForm(showParameter);
        }
    }

    @Override
    public void setFilter(SetFilterEvent e) {
        super.setFilter(e);
        List<String> ids = new ArrayList<>();
        ids.add(String.valueOf(UserServiceHelper.getCurrentUserId()));
//        e.getQFilters().add(new QFilter("yrpg_maintainer.id", QCP.in, ids));
    }


    @Override
    public void mobFilterSortInit(MobFilterSortInitArgs args) {
        super.mobFilterSortInit(args);
        List<FilterColumn> filterColumnList = args.getMobFilterSortInitEvent().getFilterColumns();
        FilterColumn orgColumn = args.getMobFilterSortInitEvent().getFilterColumn("yrpg_maintainer.number");
        if (orgColumn == null) {
            orgColumn = new CommonFilterColumn();
            ((FilterColumn) orgColumn).setCaption(new LocaleString("市场维护人"));
            ((FilterColumn) orgColumn).setFieldName("yrpg_maintainer.number");
        }
        if (!filterColumnList.contains(orgColumn)) {
            String userId = String.valueOf(UserServiceHelper.getCurrentUserId());
            orgColumn.setDefaultValue(userId);
        }
        args.getMobFilterSortInitEvent().addFilterColumn((FilterColumn) orgColumn);
    }
}