package yrpg.yrpgapp.crmvisit.plugin.crm;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.form.CloseCallBack;
import kd.bos.form.MobileFormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.control.Control;
import kd.bos.form.events.BeforeCreateListDataProviderArgs;
import kd.bos.form.plugin.AbstractMobFormPlugin;
import kd.bos.list.BillList;
import kd.bos.list.events.CreateListDataProviderListener;
import kd.bos.mvc.list.ListDataProvider;
import kd.bos.servicehelper.workflow.WorkflowServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;
import java.util.Optional;

/**
 * 流程中心：yrpg_processcenter
 * 动态表单插件(移动端)
 */
public class ProcessCenterMobFormPlugin extends AbstractMobFormPlugin implements Plugin, CreateListDataProviderListener {

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        this.addClickListeners("yrpg_home");
    }
    @Override
    public void click(EventObject evt) {
        super.click(evt);
        Control source = (Control)evt.getSource();
        String key = source.getKey();
        if (key.equals("yrpg_home")){
            MobileFormShowParameter showParameter = new MobileFormShowParameter();
            showParameter.setFormId("yrpg_firstpage");
            showParameter.setCloseCallBack(new CloseCallBack(this, "yrpg_firstpage"));
            showParameter.getOpenStyle().setShowType(ShowType.Floating);
            this.getView().showForm(showParameter);
        }
    }

    @Override
    public void initialize() {
        super.initialize();
        BillList billList = getControl("yrpg_billlistap");
        billList.addCreateListDataProviderListener(this);
    }

    @Override
    public void createListDataProvider(BeforeCreateListDataProviderArgs arg0) {
        arg0.setListDataProvider(new ListDataProvider() {
            public DynamicObjectCollection getData(int start, int limit) {
                //获取空白数据行，主要为了取列表的数据显示格式和需要赋值的字段标识
                DynamicObjectCollection allRows = super.getData(start, limit);
                //获取待办任务 类型。可查询待办任务(toHandle)、已办任务(handled)，在办申请(toApply)，已办申请(applyed)
                String userId = String.valueOf(RequestContext.get().getCurrUserId());
                Long toHandle = WorkflowServiceHelper.getTaskCountByType(userId, "toHandle");
                DynamicObjectCollection resultList = WorkflowServiceHelper.getToHandleTasksByUserId(0, toHandle.intValue(), userId);
                //对结果集进行处理，添加到allRows中
                if (Optional.ofNullable(resultList).isPresent()) {
                    resultList.forEach(entity-> {
                        DynamicObject dynamicObject = allRows.addNew();
                        dynamicObject.set("entryentity.yrpg_processtheme",entity.get("ENTITYNAME"));
                        dynamicObject.set("entryentity.yrpg_promoter",entity.get("STARTNAME"));
                        dynamicObject.set("entryentity.yrpg_initiationtime",entity.get("CREATEDATE"));

                    });
                }
                //返回结果
                return allRows;
            }
        });
    }
}